﻿-- ** Meliandah / Animal Species - PIG PACK / 04.03.2019  ** --
-- Version : 1.0
-- Add x8 new pigs !
 
animalSpecies_PigPack = {};
animalSpecies_PigPack.animalName = {};
animalSpecies_PigPack.fillTypeIndex = {};
currentModDirectory = "";
animalSpecies_PigPack.counter = 0;  

--GET THE MOD DIR
for _,mod in pairs(g_modManager.nameToMod) do
    if string.find( mod.modName, "SavagePig" ) ~= nil then
        currentModDirectory = mod.modDir;
    end;
end;  
    
--FUNCTION DEBUG
function animalSpecies_PigPack:debug(message)
  print(('### Animal Species : %s'):format(message));
end;

--  FUNCTION TO PRINT TABLES RECURSIVELY
function printer(myTable)
    DebugUtil.printTableRecursively( myTable, "-",5,10);
end;

--FUNCTION TO DEEPCOPY TABLES TO DONT PASS REFERENCES/POINTERS
function deepcopy(orig)
    copies = {};
    local orig_type = type(orig);
    local copy;
    if orig_type == 'table' then
        if copies[orig] then
            copy = copies[orig];
        else
            copy = {};
            for orig_key, orig_value in next, orig, nil do
                copy[deepcopy(orig_key, copies)] = deepcopy(orig_value, copies);
            end;
            copies[orig] = copy;
            setmetatable(copy, deepcopy(getmetatable(orig), copies));
        end
    else -- number, string, boolean, etc
        copy = orig;
    end
    return copy;
end;

--FUNCTIONS PADDERS + TERNARY
function animalSpecies_PigPack:rpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies_PigPack:ternary(str ~= nil, string.rep(char, len - #tostring(str)) .. tostring(str), string.rep(char, len));
end
function animalSpecies_PigPack:lpad(str, len, char)
    if len == nil then len = 15 end
    if char == nil then char = ' ' end
    return animalSpecies_PigPack:ternary(str ~= nil, tostring(str) .. string.rep(char, len - #tostring(str)), string.rep(char, len));
end
function animalSpecies_PigPack:ternary(cond, T, F)
    return cond and T or F;--REAL TERNARY IN-SCRIPT
end

function animalSpecies_PigPack:printAnimalTypes()
    --PRINT THE SPECIAL TAG
  print("WMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMWWMMMMMMMMMMMMMMMMMMMMMMMM");
  print("MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM");
  print("MMMMMMNK0KNWMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMNX00XWMMMMM");
  print("MMMMNkldxdddxk0KXXNWMMMMMMMMMMMWWWNXOdkKWMMMMMMMMMWWNXK0OxdddxdooKMMMM");
  print("MMMWxcOWWWNXOxxxdddddKMMMMMMMKlcdxoc,:dllddokWMMNkdddddxxk0NWWWXocKMMM");
  print("MMM0cxWWWWWWWWWWWWWXo;xXWX0Oko;oXNXKOKWKxo;.cOK0c:kNWWWWWWWWWWWWKcoWMM");
  print("MMWdcKWWWWWWWWWWWWWWd..cdddxxk0NWWWWWWWWWXkxxxdc':KWWWWWWWWWWWWWWxc0MM");
  print("MMXloNWWWWWWWWWWWWWXxlkKNWWWWWWWWWWWWWWWWWWWWWWNKk0WWWWWWWWWWWWWWOckMM");
  print("MMKcdWWWWWWWWWWWWWW0KWWWWWWWWWWWWWWWWWWWWWWWWWWWWX0XWWWWWWWWWWWWW0cxMM");
  print("MMXloNWWWWWWWWWWWWK0NWWWWWWWWWWWWWWWWWWWWWWWWWWWWWX0NWWWWWWWWWWWWOckMM");
  print("MMWdlKWWWWWWWWWWNKKNWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWX0XWWWWWWWWWWWdcKMW");
  print("MMMKloXWWWWWWWWX0KNWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWX0KNWWWWWWWWOcxWWM");
  print("MMMM0loONWWWNXKKNWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWWNXKKXNWWWKxcxNMMM");
  print("MMMMMNOlckXXKXNWWWWWWWWWKxdKWWWWWWWWWWWWWWWWNkoONWWWWWWWXKKXXKx;dWMMMM");
  print("MMMMMMNdcKWWWWWWWWWWWWWNl  :XWWWWWNNNNWWWWWWx. .OWWWWWWWWWWWWWNocKMMMM");
  print("MMMMMMO:kWWWWWWWWWWWWWWX;  'kXKXXXXXXXXXXXKKl  .xWWWWWWWWWWWWWWKcdWMMM");
  print("MMMMMNolXWWWWWWWWWWWWWWNo,:xKNNWWWWWWWWWWWNXOl,:0WWWWWWWWWWWWWWWdcKMMM");
  print("MMMMMKcdWWWWWWWWWWWWWWXKKXWWWWWWWWWWWWWWWWWWWWNKKXNWWWWWWWWWWWWWOckMMM");
  print("MMMMM0:xWWWWWWWWWWWWNKKNWWWWWWWWWWWWWWWWWWWWWWWWNK0XWWWWWWWWWWWW0:xMMM");
  print("MMMMMKcxWWWWWWWWWWWWKKNWWWWWWW0k0WWWWWWXkONWWWWWWWK0NWWWWWWWWWWW0:xMMM");
  print("MMMWMXloNWWWWWWWWWWX0NWWWWWWWX: cXWWWWWx.'OWWWWWWWWKKWWWWWWWWWWWkcOMMM");
  print("MMWMMWxc0WWWWWWWWWWK0NWWWWWWWX; :XWWWWWd..OWWWWWWWWK0NWWWWWWWWWXllNMMM");
  print("WWMMMMXolXWWWWWWWWWX0NWWWWWWWX; :XWWWWWd..kWWWWWWWWKKWWWWWWWWWNdc0MMMM");
  print("MMMMMMMKllKWWWWWWWWN0KWWWWWWWX; :XWWWWWd..kWWWWWWWX0XWWWWWWWWNdcOWMMMM");
  print("MMMMMMMMXdckNWWWWWWWNKKNWWWWWX: cXWWWWWx.'OWWWWWWK0XWWWWWWWW0lo0MMMMMM");
  print("MMMMMMMMMW0olkXWWWWWWWXKKNWWWWKOKWWWWWWXO0NWWWNXKKNWWWWWWNOolkNMMMMMMM");
  print("MMMMMMMMMMMW0xodkKNWWWWNXKKKXNWWWWWWWWWWWWNXXKKXNWWWWWXOdodONMMMMMMMMM");
  print("MMMMMMMMMMMMMMN0xdddxOKXNWWXXKKXXXXXXXKKXXKXXNWWNKOkxdddOXWMMMMMMMMMMM");
  print("MMMMMMMMMMMMMMMMMWX0kxdddddxxxkkkkxxxxxkkkkxxxddddxxOXWMMMMMMMMMMMMMMM");
  print("MMMMMMMMMMMMMMMMMMMMMMMWNXK0OkkkxxxxxxxxxkkOO0KNWMMMMMMMMMMMMMMMMMMMMM");
  print("MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM");
  print("                    SAVAGE PIGS RUSHED INTO CORE ENGINE !!!!!\n");
  
  --animalSpecies_PigPack:debug('printing Animal Manager');
  --DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager, "---", 5, 10);  
  -- animalSpecies_PigPack:debug('printing animalTypes');
  -- DebugUtil.printTableRecursively(g_currentMission.inGameMenu.pageAnimals.animalManager.animals, ".", 0, 10);
  
  animalSpecies_PigPack:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
    :format(animalSpecies_PigPack:rpad('type'), animalSpecies_PigPack:rpad('subTypeName', 25), animalSpecies_PigPack:rpad('strawPerDay'), animalSpecies_PigPack:rpad('waterPerDay'),  animalSpecies_PigPack:rpad('foodPerDay'), 
            animalSpecies_PigPack:rpad('manurePerDay'), animalSpecies_PigPack:rpad('liquidManurePerDay'), animalSpecies_PigPack:rpad('milkPerDay'), animalSpecies_PigPack:rpad('palletsPerDay'), animalSpecies_PigPack:rpad('birthRatePerDay'),animalSpecies_PigPack:rpad('foodSpillagePerDay', 20) ));

  for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do      
	  for sk,sv in pairs(v.subTypes) do
     animalSpecies_PigPack:debug(('%s | %s | %s | %s | %s | %s | %s | %s | %s | %s | %s')
        :format(animalSpecies_PigPack:rpad(v.class), animalSpecies_PigPack:rpad(sv.subTypeName, 25), animalSpecies_PigPack:rpad(sv.input.strawPerDay), animalSpecies_PigPack:rpad(sv.input.waterPerDay),  animalSpecies_PigPack:rpad(sv.input.foodPerDay), 
                animalSpecies_PigPack:rpad(sv.output.manurePerDay), animalSpecies_PigPack:rpad(sv.output.liquidManurePerDay), animalSpecies_PigPack:rpad(sv.output.milkPerDay), animalSpecies_PigPack:rpad(sv.output.palletsPerDay), animalSpecies_PigPack:rpad(sv.breeding.birthRatePerDay),animalSpecies_PigPack:rpad(sv.output.foodSpillagePerDay, 20)));
	  end;
  end;
end;

function animalSpecies_PigPack:updateAnimalTypes()

    for k,v in pairs(g_currentMission.inGameMenu.pageAnimals.animalManager.animals) do 
       
        for sk,sv in pairs(v.subTypes) do            
          
            if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_WHITE_BREEDER' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x10 (more breeding)'):format(sv.storeInfo.shopItemName);                
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;                
            end;
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_WHITE_MANURE' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x10 (more manure)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_WHITE_MANURE' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x5 (more manure)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;     
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_WHITE_BREEDER' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x5 (more breeding)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;  
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_RED_MANURE' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x50 (more manure)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;     
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_RED_BREEDER' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x50 (more breeding)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;  
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_MANURE' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x100 (more manure)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;     
            
            if sv.fillTypeDesc.name == 'PIG_TYPE_BLACK_BREEDER' then
                if string.find(sv.storeInfo.shopItemName, "Pig") ~= nil then
                    sv.storeInfo.shopItemName = "Savage "..sv.storeInfo.shopItemName;
                elseif string.find(sv.storeInfo.shopItemName, "Cochon") ~= nil then
                    string.gsub(sv.storeInfo.shopItemName, "Cochon", "Cochon sauvage");
                end;
                sv.storeInfo.shopItemName = ('%s - x100 (more breeding)'):format(sv.storeInfo.shopItemName);
                sv.subTypeName = sv.storeInfo.shopItemName;
                sv.title = sv.storeInfo.shopItemName;  
            end;       
        end;--FIN DU FOR SV   
    end; --FIN DU FOR V  
end;-- FIN FUNCTION

--FUNCTION TO LOAD ANIMAL FROM XML
function animalSpecies_PigPack:loadMyAnimal()
    --LOAD ANIMALS
    local xmlHand = loadXMLFile("animals", currentModDirectory.."husbandryFile/HusbandryAnimals.xml");    
    if g_animalManager:loadAnimals( xmlHand, "") == false then
        print("ERREUR LOADING ANIMAL !!!!!!!!");
    else
        print("ANIMALS LOADED! SAVAGE PIG ARE RUSHING...");
    end;    
    
    --LOAD FOOD GROUP
    local xmlFood = loadXMLFile("animalFood", currentModDirectory.."husbandryFile/savagePigFoodGroup.xml"); 
    if g_animalFoodManager:loadFoodGroups( xmlFood ) == true then
        print("SAVAGE PIG FOOD LOADED !");
    else
        print("NO COOKIES FOR SAVAGE PIG !");
    end;
    
    --GET AND SAVE ANIMAL HUSBANDRY FILE FOR HUSBANDRY DRAWING
    local xmlHusbandry = loadXMLFile("animalHusbandry", currentModDirectory.."husbandryFile/savagePigAnimalHusbandry.xml");
    createFolder("C:/FS19_AnimalSpecies_SavagePigPack/");
    --SAVE FILE FOR THE HUSBANDRY TO READ THEM
    saveXMLFileTo( xmlHusbandry, "C:/FS19_AnimalSpecies_SavagePigPack/savagePigAnimalHusbandry.xml");    
end;

function animalSpecies_PigPack:loadMap(name) 
    animalSpecies_PigPack:addCustomFillType();    
    animalSpecies_PigPack:loadMyAnimal();
    animalSpecies_PigPack:updateAnimalTypes();
    animalSpecies_PigPack:printAnimalTypes();
    
    printer(g_modManager);
end;

--ADD CUSTOM FILL TYPE
function animalSpecies_PigPack:addCustomFillType()
    -- ADD NEW FILL TYPES      
    --BLACK WHITE BREEDER
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[75]);--TAKE FROM BLACK WHITE PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_WHITE_BREEDER";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );
    --BLACK WHITE MANURE
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[75]);--TAKE FROM BLACK WHITE PIG
    customWhitePig.name = "PIG_TYPE_BLACK_WHITE_MANURE";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );
    -- WHITE BREEDER
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[74]);--TAKE FROM WHITE PIG     
    customWhitePig.name = "PIG_TYPE_WHITE_BREEDER";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );
    -- WHITE MANURE
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[74]);--TAKE FROM WHITE PIG     
    customWhitePig.name = "PIG_TYPE_WHITE_MANURE";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );    
    --BLACK BREEDER
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[76]);--TAKE FROM BLACK  PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_BREEDER";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );
    --BLACK MANURE
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[76]);--TAKE FROM BLACK  PIG     
    customWhitePig.name = "PIG_TYPE_BLACK_MANURE";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );
    --RED BREEDER
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[73]);--TAKE FROM red PIG     
    customWhitePig.name = "PIG_TYPE_RED_BREEDER";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );
    --RED MANURE  
    customWhitePig={};
    customWhitePig = deepcopy(g_fillTypeManager.fillTypes[73]);--TAKE FROM red PIG     
    customWhitePig.name = "PIG_TYPE_RED_MANURE";
    animalSpecies_PigPack:insertFillType( deepcopy(customWhitePig) );    
end;

--INSERT FILL TYPE IN GAME
function animalSpecies_PigPack:insertFillType( customFillType )
    --START INSERT EVERYWHERE
    table.insert( g_fillTypeManager.indexToName, customFillType.name);
    
    for index,fillTName in pairs(g_fillTypeManager.indexToName) do
        if fillTName == customFillType.name then
            FillType[customFillType.name] = index;
            animalSpecies_PigPack.fillTypeIndex[customFillType.name] = index;
            customFillType.index = index;
            g_fillTypeManager.categoryIndexToFillTypes[16][index] = true;
            g_fillTypeManager.categoryNameToFillTypes["ANIMAL"][index] = true;
            g_fillTypeManager.fillTypes[index] = deepcopy(customFillType);--1ST DEEPCOPY
            g_fillTypeManager.indexToFillType[index] = g_fillTypeManager.fillTypes[index];   
            g_fillTypeManager.indexToName[index] = customFillType.name;
            g_fillTypeManager.nameToIndex[fillTName] = index;            
            g_fillTypeManager.nameToFillType[fillTName] = g_fillTypeManager.fillTypes[index];
            g_currentMission.fillTypeManager.categoryIndexToFillTypes[16][index] = true;
            g_currentMission.fillTypeManager.categoryNameToFillTypes["ANIMAL"][index] = true;
            g_currentMission.fillTypeManager.fillTypes[index] = g_fillTypeManager.fillTypes[index];
            g_currentMission.fillTypeManager.indexToFillType[index] = g_fillTypeManager.fillTypes[index];
            g_currentMission.fillTypeManager.indexToName[index] = customFillType.name;            
            g_currentMission.fillTypeManager.nameToIndex[fillTName] = index;            
            g_currentMission.fillTypeManager.nameToFillType[fillTName] = g_fillTypeManager.fillTypes[index];             
            --print(("INSERTED SAVAGE FILLTYPE %s"):format(customFillType.name));
        end;
    end;
end;

function animalSpecies_PigPack:keyEvent(unicode, sym, modifier, isDown)
end;

function animalSpecies_PigPack:update(dt)
    --REFRESH EVERY 1000 LOOPS, IF NEW HUSBANDRY ARE ADDED AND ETC
    if animalSpecies_PigPack.counter >= 1000 then
        --GET HUSBANDRIES OF SAVAGE PIG AND PUT MAX ANIMALS AT 1000, SET MANURE LANGUAGE AND RE-SET XML Name FOR CUSTOM MAP 
        for i,j in pairs(g_currentMission.husbandries) do                        
            for _,modu in pairs(j.modulesByName) do
                
                if modu.animalType == "SAVAGE_PIG" then
                    modu.maxNumAnimals = 1000;                    
                    --print("SAVAGE PIG KICK AWAY THE MAX NUM SECURITY GUARD ! MAX NUM ANIMALS : 1000");
                end;
                
                --PUT BACK TRANSLATION FOR MANURE HEAP 
                if modu.manureHeapName ~= nil then
                    modu.manureHeapName = "$l10n_ui_PIGManureHeap";
                end;                                 
            end;                
        end;
        animalSpecies_PigPack.counter = 0;        
    end; 
    animalSpecies_PigPack.counter = animalSpecies_PigPack.counter+1;      
end;

function animalSpecies_PigPack:draw()
end;

function animalSpecies_PigPack:deleteMap()
end;

function animalSpecies_PigPack:mouseEvent(posX, posY, isDown, isUp, button)
end;

addModEventListener(animalSpecies_PigPack);